/*
 * Copyright 2002
 *  Bob Shaffer II
 *  4517 West Melissa Court
 *  Jacksonville, Florida 32210
 *  United States of America
 * All rights reserved.
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

// Some I/O manipulators that output ANSI codes
#include "ansio.h"

ostream &ClrScr(ostream &out) {
	out<<"\033[2J\033[H"<<flush;
	return out;
}

ostream &HideText(ostream &out) {
	out<<"\033[40;30m"<<flush;
	return out;
}

ostream &UnhideText(ostream &out) {
	out<<"\033[00m"<<flush;
	return out;
}

ostream &Black(ostream &out) {
	out<<"\033[0;30m";
	return out;
}

ostream &Red(ostream &out) {
	out<<"\033[0;31m";
	return out;
}

ostream &Green(ostream &out) {
	out<<"\033[0;32m";
	return out;
}

ostream &Orange(ostream &out) {
	out<<"\033[0;33m";
	return out;
}

ostream &Blue(ostream &out) {
	out<<"\033[0;34m";
	return out;
}

ostream &Magenta(ostream &out) {
	out<<"\033[0;35m";
	return out;
}

ostream &Cyan(ostream &out) {
	out<<"\033[0;36m";
	return out;
}

ostream &White(ostream &out) {
	out<<"\033[0;37m";
	return out;
}

ostream &Gray(ostream &out) {
	out<<"\033[1;30m";
	return out;
}

ostream &LtRed(ostream &out) {
	out<<"\033[1;31m";
	return out;
}

ostream &LtGreen(ostream &out) {
	out<<"\033[1;32m";
	return out;
}

ostream &Yellow(ostream &out) {
	out<<"\033[1;33m";
	return out;
}

ostream &LtBlue(ostream &out) {
	out<<"\033[1;34m";
	return out;
}

ostream &LtMagenta(ostream &out) {
	out<<"\033[1;35m";
	return out;
}

ostream &LtCyan(ostream &out) {
	out<<"\033[1;36m";
	return out;
}

ostream &LtWhite(ostream &out) {
	out<<"\033[1;37m";
	return out;
}

