/*
 * Copyright 2002
 *  Bob Shaffer II
 *  4517 West Melissa Court
 *  Jacksonville, Florida 32210
 *  United States of America
 * All rights reserved.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 */

#include "cgi_query.h"

/*
class cgi_query {
   friend istream;
   public:
   cgi_query(int Auto=0);
   cgi_query(const char *cstring);
   string VarName(long column);
   string Value(long column);
   string GetVar(char *VName);
   long length();
   private:
   void Restore_Spaces(string &S);
   vector<Delimited_Row> Var_Val_Pairs;
};
*/

cgi_query::cgi_query(int Auto) {
    if (Auto) {
        if (getenv("REQUEST_METHOD")) {
            if (string(getenv("REQUEST_METHOD"))==string("POST")) {
                cin>>(*this);
            } else if (string(getenv("REQUEST_METHOD"))==string("GET")) {
                (*this)=cgi_query(getenv("QUERY_STRING"));
                //	
    		} else {
                // Danger Will Robinson!!
                cout<<"Content-type: text/plain\n\nUnrecognized query method.\n";
                exit(-1);
            }
        }
    }
}		

cgi_query::cgi_query(const char *cstring) {
    Delimited_Row cells, empty_row;
    cells.set_delimiter("&");
    cells.set_row(cstring);
    for (long l=0; l<cells.length(); ++l) {
        Delimited_Row NewElement;
        NewElement.set_delimiter("=");
        NewElement.set_row(cells.cell(l));
        Var_Val_Pairs.push_back(empty_row);
        Var_Val_Pairs[l]=NewElement;
    }
}

string cgi_query::VarName(long column) {
    return Var_Val_Pairs[column][0];
}

string cgi_query::Value(long column) {
    string retval(Var_Val_Pairs[column][1]);
    Restore_Spaces(retval);
    return retval;
}

string cgi_query::GetVar(char *VName) {
    for (long l=0; l<length(); ++l) {
        if (VarName(l)==string(VName)) return Value(l);
    }
    return string("");
}

long cgi_query::length() {
    return Var_Val_Pairs.size();
}

void cgi_query::Restore_Spaces(string &S) { // Also restore "Ctrl-Chars"
   for (int A=0; A<S.length(); A++) {
      if (S[A]=='+') S[A]=' ';
      if (S[A]=='%') {
         string HexNum(S, A+1, 2);
         char C=(char)strtol(HexNum.c_str(), NULL, 16);
         S.replace(A, 3, 1, C);
      }
   }
}

istream &operator>>(istream &in, cgi_query &MyQuery) {
    string s;
    getline(in, s);
    MyQuery=cgi_query(s.c_str());
    return in;
}
